<template>
  <el-dialog
    v-loading="loading"
    :title="title"
    :center="true"
    align="left"
    top="18vh"
    width="500px"
    :close-on-click-modal="false"
    :visible.sync="showModelThis"
    element-loading-text="拼命加载中"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0.8)"
    @close="showModelThis = false"
  >
    <el-card style="margin: -20px 0 0 0">
      <el-row :gutter="10">
        <el-col :span="24">
          <el-form
            ref="ruleForm"
            :model="ruleForm"
            status-icon
            :rules="rulesThis"
            label-width="80px"
            class="demo-ruleForm"
          >
            <el-form-item label="平台名称" prop="platform_name">
              <el-input
                v-model="ruleForm.platform_name"
                :disabled="id == '007'"
                placeholder="平台名称"
                maxlength="20"
              />
            </el-form-item>
            <el-form-item label="平台类型" prop="use_type">
              <el-select
                v-model="ruleForm.use_type"
                style="width: 100%"
                :disabled="id == '007'"
                placeholder="请选择平台类型"
              >
                <el-option
                  v-for="item in use_type_options"
                  :key="item.value"
                  :label="item.label"
                  :value="item.value"
                >
                </el-option>
              </el-select>
            </el-form-item>
            <el-form-item label="对接平台" prop="platform_type">
              <el-select
                v-model="ruleForm.platform_type"
                style="width: 100%"
                :disabled="id == '007'"
                placeholder="请选择对接平台"
              >
                <el-option
                  v-for="item in options"
                  :key="item.value"
                  :label="item.label"
                  :value="item.value"
                >
                </el-option>
              </el-select>
            </el-form-item>
          </el-form>
        </el-col>
        <el-col :span="24" style="text-align: right">
          <el-button v-if="id !== '007'" type="primary" @click="submitForm"
            >保 存
          </el-button>
          <el-button @click="showModelThis = false">{{
            id == "007" ? "关 闭" : "取 消"
          }}</el-button>
        </el-col>
      </el-row>
    </el-card>
  </el-dialog>
</template>
<script>
import asyncRequest from "@/apis/service/serviceParam/terrace";
import resToken from "@/mixins/resToken";
export default {
  name: "terrace",
  props: ["showModel", "id", "sitem"],
  mixins: [resToken],
  data() {
    return {
      loading: false,
      title: "添加平台",
      showModelThis: this.showModel,
      options: [
        { value: "0", label: "无对接" },
        { value: "1", label: "有赞平台" },
      ],
      use_type_options: [
        { value: "1", label: "ToB" },
        { value: "2", label: "ToC" },
      ],
      ruleForm: {
        id: "",
        platform_name: "",
        platform_type: "0",
        use_type: "1",
      },
      rulesThis: this.rules,
      rules: {
        platform_name: [{ required: true, message: "平台名称不能为空", trigger: "blur" }],
        platform_type: [{ required: true, message: "请选择对接平台", trigger: "change" }],
        use_type: [{ required: true, message: "请选择平台类型", trigger: "change" }],
      },
    };
  },
  watch: {
    showModel: function (val) {
      this.showModelThis = val;
      if (val) {
        this.initForm();
      }
    },
    showModelThis(val) {
      if (!val) {
        this.$emit("cancel");
      }
    },
  },
  methods: {
    async initForm() {
      this.loading = true;
      if (this.id === "003") {
        this.title = "添加平台";
        this.rulesThis = this.rules;
      } else if (this.id === "005") {
        this.title = "修改平台";
        this.rulesThis = this.rules;
      } else {
        this.title = "平台详情";
        this.rulesThis = {};
      }
      await this.resetForm();
      this.loading = false;
    },
    async resetForm() {
      // 重置
      await this.$nextTick(() => {
        if (this.$refs.ruleForm) {
          this.$refs.ruleForm.resetFields();
          this.$refs.ruleForm.clearValidate();
          const { id, platform_name, platform_type, use_type } = this.sitem;
          this.ruleForm = {
            id: id || "",
            platform_name: platform_name || "",
            platform_type: platform_type || "0",
            use_type: use_type || "",
          };
        }
      });
    },
    async submitForm() {
      await this.$refs.ruleForm.validate(async (valid) => {
        if (valid) {
          if (this.loading) {
            return;
          }
          this.loading = true;
          let model = JSON.parse(JSON.stringify(this.ruleForm));
          let res = {};
          if (this.id === "003") {
            delete model["id"];
            res = await asyncRequest.add(model);
          } else {
            res = await asyncRequest.update(model);
          }
          this.loading = false;
          if (res && res.code === 0) {
            const title = this.id === "003" ? "添加成功!" : "修改成功!";
            this.$notify.success({
              title,
              message: "",
            });
            this.showModelThis = false;
            // 刷新
            this.$emit("refresh");
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        } else {
          console.log("error submit!!");
          return false;
        }
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.terrace {
}
</style>
